<?php
namespace Teknisa\CTB\Factories;

use Doctrine\ORM\EntityManager;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;

class Ctb24000BalanceteFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function execProcBALANCETE_OFICIAL(
        $cdempresa, $cdcontini, $cdcontfin, $datainic, $datafin, $nivel, $encerramento
    ){
        $procedure = new StoredProcedure($this->entityManager->getConnection(), 'BALANCETE_OFICIAL');
        $procedure->addParam(new Param('P_CDEMPRESA'    , Param::PARAM_INPUT , $cdempresa    , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCONTINI'  , Param::PARAM_INPUT , $cdcontini  , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCONTFIN', Param::PARAM_INPUT , $cdcontfin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAINIC' , Param::PARAM_INPUT , $datainic , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DATAFIN' , Param::PARAM_INPUT , $datafin , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NIVEL'  , Param::PARAM_INPUT , $nivel  , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDENCERRAMENTO'  , Param::PARAM_INPUT , $encerramento  , Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRBALANCETE'   , Param::PARAM_OUTPUT, null, Param::PARAM_TYPE_STR, 12));
        $nrbalancete = $procedure->execute();

        return $nrbalancete['P_NRBALANCETE'];
    }

}